Image Functions and Classes
Source Coding Module

## Functions

ITPP_EXPORT char | itpp::pnm_type (const std::string &filename)
| Determines the type of a PNM file, based on magic numbers. The returned value is a character between '1' and '6'. If an error occured, the returned value is the character '0'. More...
ITPP_EXPORT bool | itpp::pnm_info (const std::string &filename, char &pnm_type, int &width, int &height, int &max_val, std::string &comments)
| Retrieve some information about an pnm file. More...
ITPP_EXPORT bool | itpp::pgm_read (const std::string &filename, imat &m, std::string &comments)
| Read the entire graymap into the matrix m or return false if the function failed. More...
ITPP_EXPORT bool | itpp::pgm_read (const std::string &filename, imat &m, int r1, int r2, int c1, int c2)
| Read a part of the graymap into the matrix m. More...
ITPP_EXPORT imat | itpp::pgm_read (const std::string &filename)
| Read a pgm file of name filename and return the corresponding matrix of integers. Return a void matrix if an error ocurred. More...
ITPP_EXPORT bool | itpp::pgm_write (const std::string &filename, const imat &m, const std::string &comments="Generated by IT++ (http://itpp.sourceforge.net)")
| Create an image file from the matrix of integer. More...
ITPP_EXPORT bool | itpp::ppm_read (const std::string &filename, imat &r, imat &g, imat &b, std::string &comments)
| Read the color image file in the format ppm. The image is retrieved as a set of three matrices, each of whom is a plan of RGB component. More...
ITPP_EXPORT bool | itpp::ppm_read (const std::string &filename, imat &r, imat &g, imat &b)
| Read the color image file in the PPM format. More...
ITPP_EXPORT bool | itpp::ppm_read (const std::string &filename, imat &r, imat &g, imat &b, int r1, int r2, int c1, int c2)
| Read a part of the pixmap into the matrix m. The parameters r1, r2, c1 and c2 are the rows and columns (inclusive) of the subimage.
ITPP_EXPORT bool | itpp::ppm_write (const std::string &filename, const imat &r, const imat &g, const imat &b, const std::string &comments="Generated by IT++ (http://itpp.sourceforge.net)", int max_val=255)
| Write the matrix m as a pixmap. More...
ITPP_EXPORT imat | itpp::img_double2int (const mat &m, int max_val=255, double double_min=0, double double_max=1)
| Prepare a matrix of double to be writted as an image. More...
ITPP_EXPORT mat | itpp::img_int2double (const imat &m, int max_val=255, double double_min=0, double double_max=1)
| Return a matrix of double which is a scaled version of the input matrix m of integers. More...

## Detailed Description

The PNM graphics format is actually a family of formats consisting of PBM (black and white, not implemented yet), PGM (gray) and PPM (RGB color). This interface proposes input/output functions for images in the raw formats (type 'P4', 'P5' and 'P6').

There are several utilities available for manipulating PNM images. Search the net for the netpbm package.

## Function Documentation

ITPP_EXPORT char itpp::pnm_type | ( | const std::string & | filename | ) |

Determines the type of a PNM file, based on magic numbers. The returned value is a character between '1' and '6'. If an error occured, the returned value is the character '0'.

Parameters

  filename | The name of the file from which the image is retrieved

ITPP_EXPORT bool itpp::pnm_info | ( | const std::string & | filename,
|  | char & | pnm_type,
|  | int & | width,
|  | int & | height,
|  | int & | max_val,
|  | std::string & | comments
| ) |  |

Retrieve some information about an pnm file.

Parameters

  filename | The name of the file from which the image is retrieved
  pnm_type | The type of the pnm file (5: pgm file, 6: ppm file)
  width | The image width
  height | The image height
  max_val | The greatest possible value
  comments | The comments in the file

ITPP_EXPORT bool itpp::pgm_read | ( | const std::string & | filename,
|  | imat & | m,
|  | std::string & | comments
| ) |  |

Read the entire graymap into the matrix m or return false if the function failed.

Parameters

  filename | The name of the file from which the image is retrieved
  m | The matrix in which the image will be stored
  comments | This std::string variable is used to retrieve the comments of the file

ITPP_EXPORT bool itpp::pgm_read | ( | const std::string & | filename,
|  | imat & | m,
|  | int | r1,
|  | int | r2,
|  | int | c1,
|  | int | c2
| ) |  |

Read a part of the graymap into the matrix m.

Parameters

  filename | The name of the file from which the image is retrieved
  m | The matrix in which the image will be stored
  r1 | first row to be included in the matrix
  r2 | last row to be included in the matrix
  c1 | first column to be included in the matrix
  c2 | last column to be included in the matrix

ITPP_EXPORT imat itpp::pgm_read | ( | const std::string & | filename | ) |

Read a pgm file of name filename and return the corresponding matrix of integers. Return a void matrix if an error ocurred.

Parameters

  filename | The name of the file from which the image is retrieved

ITPP_EXPORT bool itpp::pgm_write | ( | const std::string & | filename,
|  | const imat & | m,
|  | const std::string & | comments = `"Generated by IT++ (http://itpp.sourceforge.net)"`
| ) |  |

Create an image file from the matrix of integer.

Parameters

  filename | The name of the image file to create
  m | The matrix of integer representing the image
  comments | Comments included in the file

Coefficients greater than 255 and smaller than 0 are clipped.

ITPP_EXPORT bool itpp::ppm_read | ( | const std::string & | filename,
|  | imat & | r,
|  | imat & | g,
|  | imat & | b,
|  | std::string & | comments
| ) |  |

Read the color image file in the format ppm. The image is retrieved as a set of three matrices, each of whom is a plan of RGB component.

Parameters

  filename | The name of the file to be read
  r | the red component of the image
  g | the green component of the image
  b | the blue component of the image
  comments | a string variable to retrieve the comments contained in the file header.

ITPP_EXPORT bool itpp::ppm_read | ( | const std::string & | filename,
|  | imat & | r,
|  | imat & | g,
|  | imat & | b
| ) |  |

Read the color image file in the PPM format.

Parameters

  filename | The name of the file to be read
  r | the red component of the image
  g | the green component of the image
  b | the blue component of the image

ITPP_EXPORT bool itpp::ppm_write | ( | const std::string & | filename,
|  | const imat & | r,
|  | const imat & | g,
|  | const imat & | b,
|  | const std::string & | comments = `"Generated by IT++ (http://itpp.sourceforge.net)"`,
|  | int | max_val = `255`
| ) |  |

Write the matrix m as a pixmap.

Parameters

  filename | The name of the file to create
  r | the red component of the image
  g | the green component of the image
  b | the blue component of the image
  comments | a comment that will be inserted in the image file
  max_val | The maximum value of a component. This quantity should be lower than 255 (raw type).

ITPP_EXPORT imat itpp::img_double2int | ( | const mat & | m,
|  | int | max_val = `255`,
|  | double | double_min = `0`,
|  | double | double_max = `1`
| ) |  |

Prepare a matrix of double to be writted as an image.

Parameters

  m | The matrix of real. The components are assumed to be between double_min and double_max, and will be scaled by factor max_val / (double_max - double_min ) in the output matrix.
  max_val | The maximum value for the output matrix. This value is usually set to 255.
  double_min | The value corresponding to the integer value 0. Note that all the values smaller that this quantity will be double_min.
  double_max | The value corresponding to the integer value max_val. Similarly to double_min, values greater than double_max will be set to double_max

ITPP_EXPORT mat itpp::img_int2double | ( | const imat & | m,
|  | int | max_val = `255`,
|  | double | double_min = `0`,
|  | double | double_max = `1`
| ) |  |

Return a matrix of double which is a scaled version of the input matrix m of integers.

Parameters

  m | The matrix of real. The components are assumed to be between 0 and 1, and will be scaled by factor max_val in the output matrix.
  max_val | The maximum value for the output matrix. This value is usually set to 255.
  double_min | The value on which the integer value 0 will be mapped
  double_max | The value on which the integer value max_val will be mapped

Generated on Thu Aug 20 2015 21:02:52 for IT++ by Doxygen 1.8.9.1